import sql from "../sql.js";
const rp = require("request-promise")
  , jsdom = require("jsdom").JSDOM;

const data = {
  abschieben: [],
  kaffee: [],
  tee: [],
  quotes_firecooler: [],
  quotes_kinski: [],
  quotes_stoll: [],
  quotes_boll: []
};

Object.keys(data).forEach(cur => {
  sql.any("select data from useless where trigger = $1 limit 1", [cur])
    .then(rows => {
      data[cur] = JSON.parse(rows[0].data);
    });
});

module.exports = bot => {
  bot._trigger.set("abschieben", new bot.trigger({
    call: /^(\.|\/)abschieben/i,
    f: e => {
      e.replyAction(`schiebt [b]${e.args[0] || e.user.nick}[/b] ${data.abschieben[~~(Math.random() * data.abschieben.length)]} ab.`);
    }
  }));

  bot._trigger.set("butterkaese", new bot.trigger({
    call: /^(\.|\/)butterkäse/i,
    f: e => {
      e.replyAction(`drischt mit einem großen Stück Butterkäse auf [b]${e.args[0] || e.user.nick}[/b] ein.`);
    }
  }));

  bot._trigger.set("notschlachten", new bot.trigger({
    call: /^(\.|\/)notschlachten/i,
    f: e => {
      e.replyAction(`notschlachtet [b]${e.args[0] || e.user.nick}[/b] und entsorgt die Leiche im Biomüll`);
    }
  }));

  bot._trigger.set("lachs", new bot.trigger({
    call: /^(\.|\/)lachs/i,
    f: e => {
      e.reply("öhöhöhöhöhöhö");
    }
  }));

  bot._trigger.set("kaffee", new bot.trigger({
    call: /^(\.|\/)kaffee/i,
    f: e => {
      e.replyAction(data.kaffee[~~(Math.random() * data.kaffee.length)]
        .replace("{user}", `[b]${e.args[0] || e.user.nick}[/b]`)
      );
    }
  }));

  bot._trigger.set("tee", new bot.trigger({
    call: /^(\.|\/)tee/i,
    f: e => {
      e.replyAction(data.tee[~~(Math.random() * data.tee.length)]
        .replace("{user}", `[b]${e.args[0] || e.user.nick}[/b]`)
      );
    }
  }));

  bot._trigger.set("uwe_quotes", new bot.trigger({
    call: /^(\.|\/)(boll|firecooler|kinski|stoll)$/i,
    f: e => {
      e.reply(data[`quotes_${e.cmd}`][~~(Math.random() * data[`quotes_${e.cmd}`].length)]);
    }
  }));

  bot._trigger.set("wusel", new bot.trigger({
    call: /^(\.|\/)wusel/i,
    f: e => {
      e.replyAction(`wuselt [b]${e.args[0] || e.user.nick}[/b] über den Haufen.`);
    }
  }));

  bot._trigger.set("mett", new bot.trigger({
    call: /^(\.|\/)mett/i,
    f: e => {
      e.reply(`Jamba Mettscanner: [b]${e.args[0] || e.user.nick}[/b] ist zu ${~~(Math.random() * 100 + 1)}% Mett.`);
    }
  }));

  bot._trigger.set("rotenburg", new bot.trigger({
    call: /^(\.|\/)rotenburg/i,
    f: e => {
      e.replyAction(`verarbeitet [b]${e.args[0] || e.user.nick}[/b] zu Hackfleisch.`);
    }
  }));

  bot._trigger.set("pee", new bot.trigger({
    call: /^(\.|\/)pee/i,
    f: e => {
      e.replyAction(`pisst in [b]${e.args[0] || e.user.nick}[/b]s Gesicht.`);
    }
  }));

  bot._trigger.set("ike", new bot.trigger({
    call: /^ike/i,
    f: e => {
      e.reply("ike ike!");
    }
  }));

  bot._trigger.set("rip", new bot.trigger({
    call: /^rip/i,
    f: e => {
      e.reply("Rust in Peace");
    }
  }));

  bot._trigger.set("haram", new bot.trigger({
    call: /^(\.|\/)haram/i,
    f: e => {
      e.reply(`[b]${e.args[0] || e.user.nick}[/b] ist ${(~~(Math.random() * 2) ? "haram" : "nicht haram")}.`);
    }
  }));

  bot._trigger.set("sacklutscher", new bot.trigger({
    call: /^(\.|\/)lutschsack/i,
    f: e => {
      e.reply(`[b]${e.user.nick}[/b] legt Rosen aus und lutscht den Sack von [b]${e.args[0] || e.user.nick}[/b]`);
    }
  }));

  bot._trigger.set("kawaii", new bot.trigger({
    call: /kawaii/i,
    f: e => {
      e.reply("⌒(o＾▽＾o)ノ so much kawaii");
    }
  }));

  bot._trigger.set("hurrdurr", new bot.trigger({
    call: /^hurr$/i,
    f: e => {
      e.reply("durr");
    }
  }));

  bot._trigger.set("fraguwe", new bot.trigger({
    call: /^uwe.*\?$/i,
    f: e => {
      e.reply("fuck you");
    }
  }));

  bot._trigger.set("wasser", new bot.trigger({
    call: /^(\.|\/)wasser/i,
    f: e => {
      e.replyAction(`kippt [b]${e.args[0] || e.user.nick}[/b] einen Eimer Wasser über den Kopf.`);
    }
  }));

  bot._trigger.set("normie", new bot.trigger({
    call: /^(\.|\/)normie/i,
    f: e => {
      e.reply(`Jamba Normiescanner: [b]${e.args[0] || e.user.nick}[/b] ist zu ${~~(Math.random() * 100 + 1)}% ein Normie.`);
    }
  }));

  bot._trigger.set("hyper", new bot.trigger({
    call: /^(\.|\/)hyper$/i,
    f: e => {
      e.reply("[b]GET HYPER![/b]");
    }
  }));

  bot._trigger.set("bark", new bot.trigger({
    call: /^(\.|\/)bark$/i,
    f: e => {
      e.reply("BARK BARK BARK");
    }
  }));

  bot._trigger.set("meditieren", new bot.trigger({
    call: /^(\.|\/)meditieren/i,
    f: e => {
      e.replyAction(`meditiert zusammen mit [b]${e.args[0] || e.user.nick}[/b] Metta.`);
    }
  }));

  bot._trigger.set("duden", new bot.trigger({
    call: /^(\.|\/)duden/i,
    f: e => {
      e.replyAction(`drischt mit einem großen Duden auf [b]${e.args[0] || e.user.nick}[/b] ein.`);
    }
  }));

  bot._trigger.set("kscht", new bot.trigger({
    call: /^(\.|\/)kscht/i,
    f: e => {
      e.replyAction(`jagt [b]${e.args[0] || e.user.nick}[/b] durch den Raum.`);
    }
  }));

  bot._trigger.set("bullenpisse", new bot.trigger({
    call: /^(\.|\/)bullenpisse/i,
    f: e => {
      e.replyAction(`zapft ein Fläschchen feinsten Bullenurin, verarbeitet diesen zu Red-Bull und serviert ihn [b]${e.args[0] || e.user.nick}[/b] in Form einer Pfanddose.`);
    }
  }));

  bot._trigger.set("lungenkrebs", new bot.trigger({
    call: /^(\.|\/)lungenkrebs/i,
    f: e => {
      e.replyAction(`dreht [b]${e.args[0] || e.user.nick}[/b] einen prall gefüllten Sargnagel mit feinstem Schwarzer Krauser.`);
    }
  }));

  bot._trigger.set("irpg", new bot.trigger({
    call: /^(\.|\/)irpg/i,
    f: e => {
      const user = e.args[0] || e.user.nick;
      rp("http://idlerpg.rizon.net/players.php").then(top => {
        let prank = 0
          , i = 1;
        const dom = new jsdom(top);
        let playerlist = dom.window.document.querySelectorAll("ol > li");
        let player = null;
        for(let p of playerlist) {
          if (p.innerHTML.includes(`player=${user}">`)) {
            prank = i;
            player = p;
            break;
          }
          i++;
        }
        if(player !== null) {
          const [, plevel, pclass, puntil] = player.innerHTML.match(/.*, the level (.*?) (.*?)\. Next level in (.*?)\./);
          e.reply(`([i]${prank} / ${playerlist.length}[/i]) [b]${user}[/b], the [b]${pclass}[/b]: level: ${plevel}, next level in ${puntil}.`);
        }
        else
          e.reply(`player [b]${user}[/b] was not found`);
      });

    }
  }));

  bot._trigger.set("blah", new bot.trigger({
    call: /^[A-ZÄÖÜẞ](?: [A-ZÄÖÜẞ]){1,5}$/,
    clients: ["irc"],
    f: e => {
      let args = e.message.trim();
      if (args.toUpperCase() === args)
        args.substring(2).split(" ").forEach(e.reply);
    }
  }));
};